
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef ivmob_TCLSERV_CLIENT_MSG_LIB_H
#define ivmob_TCLSERV_CLIENT_MSG_LIB_H

#include <server/ivmobType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int ivmobTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int ivmobTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int ivmobTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING32 *(in_device) 
		);

int ivmobTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING32 *(in_device) ,
				
				int *bilan);

int ivmobTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING32 *(in_device) ,
					
					int *bilan);




int ivmobTclservClientActivateRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 int *(in_active) 
		);

int ivmobTclservClientActivateReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientActivateRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				int *(in_active) ,
				
				int *bilan);

int ivmobTclservClientActivateRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					int *(in_active) ,
					
					int *bilan);




int ivmobTclservClientSetCmdParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CMD_PARAM *(in_cmd)
		);

int ivmobTclservClientSetCmdParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientSetCmdParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CMD_PARAM *(in_cmd) ,
				 
				 int *bilan);




int ivmobTclservClientSetKinematicsParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IVMOB_KINEMATICS_STR *(in_kinematics)
		);

int ivmobTclservClientSetKinematicsParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientSetKinematicsParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IVMOB_KINEMATICS_STR *(in_kinematics) ,
				 
				 int *bilan);




int ivmobTclservClientGetKinematicsParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int ivmobTclservClientGetKinematicsParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       IVMOB_KINEMATICS_STR *(out_kinematics),
			       int *bilan);

int ivmobTclservClientGetKinematicsParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 IVMOB_KINEMATICS_STR *(out_kinematics),
				 int *bilan);




int ivmobTclservClientGetDynamicsParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int ivmobTclservClientGetDynamicsParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       IVMOB_DYNAMIC_STR *(out_dynamics),
			       int *bilan);

int ivmobTclservClientGetDynamicsParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 IVMOB_DYNAMIC_STR *(out_dynamics),
				 int *bilan);




int ivmobTclservClientSetDynamicsParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IVMOB_DYNAMIC_STR *(in_dynamics)
		);

int ivmobTclservClientSetDynamicsParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientSetDynamicsParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IVMOB_DYNAMIC_STR *(in_dynamics) ,
				 
				 int *bilan);




int ivmobTclservClientSetVarParamRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IVMOB_VAR_PARAMS *(in_varParams)
		);

int ivmobTclservClientSetVarParamReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientSetVarParamRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IVMOB_VAR_PARAMS *(in_varParams) ,
				 
				 int *bilan);




int ivmobTclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int ivmobTclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int ivmobTclservClientTrackRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IVMOB_TRACK_PARAMS *(in_trackParams) 
		);

int ivmobTclservClientTrackReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientTrackRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IVMOB_TRACK_PARAMS *(in_trackParams) ,
				
				int *bilan);

int ivmobTclservClientTrackRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IVMOB_TRACK_PARAMS *(in_trackParams) ,
					
					int *bilan);




int ivmobTclservClientSetPomRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GENPOS_POSTER_NAME *(in_mePosterName) 
		);

int ivmobTclservClientSetPomReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientSetPomRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GENPOS_POSTER_NAME *(in_mePosterName) ,
				
				int *bilan);

int ivmobTclservClientSetPomRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GENPOS_POSTER_NAME *(in_mePosterName) ,
					
					int *bilan);




int ivmobTclservClientSetPosRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IVMOB_CART_3DCONFIG *(in_setPosStr)
		);

int ivmobTclservClientSetPosReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientSetPosRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IVMOB_CART_3DCONFIG *(in_setPosStr) ,
				 
				 int *bilan);




int ivmobTclservClientGyroRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IVMOB_GYRO_PARAMS *(in_params) 
		);

int ivmobTclservClientGyroReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientGyroRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IVMOB_GYRO_PARAMS *(in_params) ,
				
				int *bilan);

int ivmobTclservClientGyroRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IVMOB_GYRO_PARAMS *(in_params) ,
					
					int *bilan);




int ivmobTclservClientGetGyroRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int ivmobTclservClientGetGyroReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       IVMOB_GYRO_PARAMS *(out_params),
			       int *bilan);

int ivmobTclservClientGetGyroRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 IVMOB_GYRO_PARAMS *(out_params),
				 int *bilan);




int ivmobTclservClientSetOdometryMethodRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IVMOB_ODOMETRY_METHOD *(in_odometryCommand) 
		);

int ivmobTclservClientSetOdometryMethodReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientSetOdometryMethodRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IVMOB_ODOMETRY_METHOD *(in_odometryCommand) ,
				
				int *bilan);

int ivmobTclservClientSetOdometryMethodRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IVMOB_ODOMETRY_METHOD *(in_odometryCommand) ,
					
					int *bilan);




int ivmobTclservClientLogRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING128 *(in_fileName) 
		);

int ivmobTclservClientLogReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientLogRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING128 *(in_fileName) ,
				
				int *bilan);

int ivmobTclservClientLogRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING128 *(in_fileName) ,
					
					int *bilan);




int ivmobTclservClientStopLogRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int ivmobTclservClientStopLogReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientStopLogRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int ivmobTclservClientLogInternalDataRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING128 *(in_fileName) 
		);

int ivmobTclservClientLogInternalDataReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int ivmobTclservClientLogInternalDataRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING128 *(in_fileName) ,
				
				int *bilan);

int ivmobTclservClientLogInternalDataRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING128 *(in_fileName) ,
					
					int *bilan);




int ivmobTclservClientStopInternalDataLogRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int ivmobTclservClientStopInternalDataLogReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientStopInternalDataLogRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int ivmobTclservClientGotoRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_REF *(in_ref)
		);

int ivmobTclservClientGotoReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int ivmobTclservClientGotoRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_REF *(in_ref) ,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* ivmobTCLSERV_CLIENT_MSG_LIB_H */

